


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 
C                                                                      C 
C    FMASTER:   This program finds the stability curves of the 	       C
C               hydrodynamic equations in the Boussinesq approximation C
C               with different boundary conditions  (in 2 dimensions)  C 
C                                                                      C 
C                                                                      C 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 
									
	INTEGER  IND,ISTOP                                              
	OPEN(UNIT=7,FILE='OUT',STATUS='NEW')
	OPEN(UNIT=5,FILE='jeffin',STATUS='OLD')
			     
   1         READ(5,100)IND                                             
C                                                                       
C       IND decides the "sweeping" parameter                            
c       See the list of parameters in cdet
c
C                                                                  
	WRITE(7,200)IND                                            
200     FORMAT(' ','IND = ',I1)                                    
	CALL SWEEP(IND)                                            
	 READ(5,100)ISTOP                                          
	IF(ISTOP) 1,9,1                                            
9       CLOSE(UNIT=5)                                              
C9       CONTINUE                                                   
	CLOSE(UNIT=7)                                              
100     FORMAT(I1)                                                 
	STOP                                                       
	END                                                        
								   
								   
	SUBROUTINE MCIN(W,R0,ERROR,XINC,NPTOS,NEIGEN,FREE)
	REAL*8     W,R0,ERROR,XINC                                  
	REAL*8     PARM(15)                                        
	INTEGER    NPTOS,NPARM,FREE                                     
	COMMON     /PAT/PARM,NPARM                                 
C       NEIGEN = 0 do not calculate  
C       NEIGEN = 1 then do calculate 
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
		READ(5,99)NEIGEN
		READ(5,100)NPARM
		READ(5,101)NPTOS                                        
		READ(5,102)ERROR
		READ(5,102)R0
		READ(5,102)W
		READ(5,102)XINC
		DO 1 I=1,15                                                     
1               PARM(I)=0                                                  
		READ(5,102)(PARM(I),I=1,NPARM)
		READ(5,99)FREE
99              FORMAT(10X,I1)                                          
100             FORMAT(10X,I2)                                          
101             FORMAT(10X,I3)                                          
102             FORMAT(10X,D13.7)                                       
	RETURN                                                          
	END                                                             
									
	SUBROUTINE SWEEP(IND)                                           
	REAL*8 PARM(15)                                                 
	REAL*8     W,R0,VAR,VARIN,ERROR,XINC                             
	INTEGER    NPTOS,NPARM,IND,FREE                                      
	COMMON     /PAT/PARM,NPARM                                      
	    CALL MCIN(W,R0,ERROR,XINC,NPTOS,NEIGEN,FREE)                      
	    WRITE(7,200)(I,PARM(I),I=1,NPARM)                           
200         FORMAT(' ','PARM(',I2,') :  ',D13.7)                        
	    WRITE(7,201)R0,W                                             
201         FORMAT(' ','INPUT GUESS R0 = ',D13.7,'    W = ',D13.7)       
	    VARIN=PARM(IND)                                             
	    VAR=PARM(IND)                                               
	    DO 4  I=1,NPTOS                                             
	    WRITE(7,*)I 
	    IF(W) 2,1,2
    1       CALL NTN0(R0,ERROR,NEIGEN) 
	    GO TO 3                                                     
    2       CALL NEWTON(W,R0,ERROR,FREE)                                      
    3       WRITE(7,300) W,R0,VAR                                        
		   VAR=VARIN + I * XINC
		   PARM(IND) = VAR                                      
    4       CONTINUE
300       FORMAT(' ','W:  ',D13.7,3X,'R0:  ',D13.7,3X,'PAR:  ',D13.7)
	RETURN                                                          
	END                                                             
									
	SUBROUTINE   ROOT(LAM,R0,ALFA)                                   
	COMPLEX*16    ALFA(3),X(3),B,C,D,AUX,CDSQRT,LAM                 
	COMPLEX*16    CA2,CTAU,CR,UNO,DOS,TRES,DCMPLX,CBETA,CDELTA,CF,CQ                   
	REAL*8        R0,PARM(15)                                           
	COMMON     /PAT/PARM,NPARM                                      
		UNO=(1.D0,0.D0)                                               
		DOS=(2.D0,0.D0)                                         
		TRES=(3.D0,0.D0)                                        
		CA2=DCMPLX(PARM(1)*PARM(1))                               
		CTAU=DCMPLX(1.D0/PARM(2))
		CF=DCMPLX(PARM(6))
		CQ=DCMPLX(PARM(7))
		CBETA=DCMPLX((UNO+LAM*CF)/(UNO+LAM*CQ))
		CR=DCMPLX(R0)
		B=-CA2-(UNO+CTAU*CBETA)*LAM/TRES
		C=CA2*CA2+LAM*DOS*CA2*(UNO+CTAU*CBETA)/TRES                   
		C=C+LAM*LAM*CTAU*CBETA/TRES                                   
		D=CR*CA2*CBETA-(CA2+LAM)*CA2*(CA2+LAM*CTAU*CBETA)                   
	   CALL CUBIC(B,C,D,X)
	   DO  1  J=1,3                                                 
		AUX=X(J)                                                
  1             ALFA(J)=CDSQRT(AUX)                                     
	RETURN                                                          
	END

									
	SUBROUTINE  NEWTON(W,R0,ERROR,FREE)                                   
	REAL*8      ERROR,W,R0,WN,RN,DABS,DBLE,DIMAG                       
	COMPLEX*16   LAM,DET,DR,DW                                        
	INTEGER     NITER,FREE                                               
C                                                                       
C
		NITER=1                                                 
1                LAM=(0.D0,1.D0)*DCMPLX(W)                               
	      CALL CDET(LAM,R0,DET,FREE)                                     
	   CALL DERI(W,R0,DET,DR,DW)                                     
	WRITE(7,*)LAM,R0,DET,DR,DW
		WN=W-DIMAG(DET/DR)/DIMAG(DW/DR)                         
		RN=R0-DIMAG(DET/DW)/DIMAG(DR/DW)
	   IF (DABS((W-WN)/W)+DABS((R0-RN)/R0)-ERROR)  5,5,2               
  2        IF(NITER-50) 3,3,4                                           
  3             W=WN                                                    
		R0=RN                                                    
		NITER=NITER+1                                           
	   GOTO 1                                                       
  4        WRITE(*,100)                                                 
100        FORMAT(' ','ERROR: Niter is too large !!')                  
	STOP                                                            
  5     RETURN                                                          
	END                                                             
									
									
	SUBROUTINE   DERI(W,R0,DET,DR,DW)                                
	REAL*8       W,R0,WN,RN,PASO                                     
	COMPLEX*16    DET,DR,DW,X,Y,DCMPLX,LAM1,LAM2,IM
	INTEGER      FREE
C                                                                       
		PASO=1.0001D0                                           
		RN=R0*PASO                                               
		WN=W*PASO                                               
C                                                                       
	IM=(0.D0,1.D0)                                                  
	LAM1=IM*DCMPLX(W)                                               
	LAM2=IM*DCMPLX(WN)                                              
	   CALL  CDET(LAM1,RN,X,FREE)                                        
	    CALL  CDET(LAM2,R0,Y,FREE)                                        
		DR=(X-DET)/DCMPLX(RN-R0)                                 
		DW=(Y-DET)/DCMPLX(WN-W)                                 
	RETURN                                                          
	END                                                             
									
									
	SUBROUTINE    NTN0(R0,ERROR,NEIGEN)                              
	REAL*8        ERROR,DABS,R0,RN                                   
	COMPLEX*16     DET,DR,LAM                                       
	INTEGER       NITER                                             
		NITER=1                                                 
	LAM=(0.D0,0.D0)                                                 
C           CALL  CDET0(LAM,R0,DET)                                       
1          CALL  DERI0(R0,DET,DR)     
	WRITE(*,*)DET                                   
		RN=R0-dreal(DET)/dreal(DR)                               
	   IF(DABS((R0-RN)/R0)-ERROR)  5,5,2                              
  2        IF(NITER-50)  3,3,4                                          
  3             R0=RN                                                    
		NITER=NITER+1                                           
	   GOTO 1                                                       
  4        WRITE(*,100)                                                 
100        FORMAT(' ','ERROR:  NITER is too large !!')                
	STOP                                                            
  5     IF(NEIGEN.EQ.0)RETURN                                           
C           CALL EIGENF(R0)                                               
	RETURN                                                          
	END                                                             
									
									
	SUBROUTINE   DERI0(R0,DET,DR)                                    
	REAL*8       R0,RN,PASO                                          
	COMPLEX*16    DET,DR,X,DCMPLX,LAM                               
		PASO=1.0001D0                                           
		RN=R0*PASO                                               
		LAM=(0.D0,0.D0)                                         
C           CALL  CDET0(LAM,RN,X)                                         
		DR=(X-DET)/DCMPLX(RN-R0)                                 
	RETURN                                                          
	END                                                             
C                                                                      C
C              C U B I C        F O R T R A N                          C
C                                                                      C
C    Solves the equation:   X^3 + 3*B*X^2 +  3*C*X + D = 0,            C
C    Where the constants B, C, D, are complex and double precision     C
C    		                                                       C
C                                       [ R. BENGURIA 4/FEB/85]        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
									
      SUBROUTINE  CUBIC(B,C,D,X)                                        
      COMPLEX*16   X(3),Z(3)                                            
      COMPLEX*16   B,C,D,W,W2,ALFA,BETA,THETA,AUX1,AUX2,IM,AX,ALF2,ROOT 
      COMPLEX*16   UNO,DOS,TRES                                         
      COMPLEX*16   CDABS,CDLOG,CDSQRT,CDEXP                             
      INTEGER     IND,IA,IB                                             
		IM=(0.D0,1.D0)                                          
		UNO=(1.D0,0.D0)                                         
		DOS=(2.D0,0.D0)                                         
		TRES=(3.D0,0.D0)                                        
		W=(-0.5D0,0.86602540378443860D0)                        
		W2=W*W                                                  
		ALFA=C-B*B                                              
		BETA=D-C*B-DOS*B*ALFA                                   
		IA=IND(ALFA)                                            
	IF(IA.EQ.0)     GOTO 2                                          
		IB=IND(BETA)                                            
	IF(IB.EQ.0)     GOTO 1                                          
		X(1)=-B                                                 
		X(2)=-B                                                 
		X(3)=-B                                                 
	RETURN                                                          
  1             AUX1=CDLOG(BETA)/TRES                                   
		AUX2=-CDEXP(AUX1)                                       
		X(1)=AUX2-B                                             
		X(2)=AUX2*W-B                                           
		X(3)=AUX2*W2-B                                          
	RETURN                                                          
  2             ALF2=CDSQRT(ALFA)                                       
		AUX1=ALFA*ALF2*DOS                                      
		THETA=BETA/AUX1                                         
		AUX2=UNO+(BETA*BETA)/((4.D0,0.D0)*ALFA*ALFA*ALFA)       
		IA=IND(AUX2)                                            
	IF(IA.EQ.0)     GOTO 3                                          
		X(1)=-BETA/(DOS*ALFA)-B                                 
		X(2)=X(1)                                               
		X(3)=BETA/ALFA-B                                        
	RETURN                                                          
  3             ROOT=CDSQRT(AUX2)                                       
		AUX1=(ROOT+THETA)*(ROOT+THETA)                          
		AUX1=CDLOG(AUX1)/(3.D0,0.D0)                            
		AUX1=CDEXP(AUX1)                                        
		Z(1)=AUX1                                               
		Z(2)=AUX1*W                                             
		Z(3)=AUX1*W2                                            
	DO 4 J=1,3                                                      
		AX=Z(J)                                                 
		AX=(AX-UNO)/(AX+UNO)                                    
		X(J)=ALF2*(ROOT*AX-THETA)-B                             
  4     CONTINUE                                                        
	RETURN                                                          
      END                                                               
									
									
      FUNCTION    IND(ALFA)                                             
      REAL*8      XR,XI,DREAL,DIMAG,ERROR                               
      COMPLEX*16   ALFA                                                 
      INTEGER     IND                                                   
		ERROR=1.D-8                                             
		XR=DREAL(ALFA)                                          
		XI=DIMAG(ALFA)                                          
		XR=XR*XR+XI*XI                                          
	IF(XR-ERROR) 1,1,2                                              
  1             IND=1                                                   
	RETURN                                                          
  2             IND=0                                                   
	RETURN                                                          
      END                                                               
									
	FUNCTION    TGH(X)                                              
	COMPLEX*16   X,Y,Z,TGH,CDEXP                                    
		Y=CDEXP(X)                                              
		Z=(1.D0,0.D0)/Y                                         
		TGH=(Y-Z)/(Y+Z)                                         
	RETURN                                                          
	END                                                             
									
									
	FUNCTION    CSINH(X)                                            
	COMPLEX*16   X,Y,Z,CSINH,CDEXP                                  
		Y=CDEXP(X)                                              
		Z=(1.D0,0.D0)/Y                                         
		CSINH=(Y-Z)/(2.D0,0.D0)                                 
	RETURN                                                          
	END                                                             
									
									
	FUNCTION    CCOSH(X)                                            
	COMPLEX*16   X,Y,Z,CCOSH,CDEXP                                  
		Y=CDEXP(X)                                              
		Z=(1.D0,0.D0)/Y                                         
		CCOSH=(Y+Z)/(2.D0,0.D0)                                 
	RETURN                                                          
	END                                                             
									
									
	SUBROUTINE  BOX(X,Y,Z,RES)                                      
	COMPLEX*16   X(3),Y(3),Z(3)                                     
	COMPLEX*16   RES                                                
		RES=X(1)*(Y(2)*Z(3)-Y(3)*Z(2))                          
		RES=RES+X(2)*(Y(3)*Z(1)-Y(1)*Z(3))                      
		RES=RES+X(3)*(Y(1)*Z(2)-Y(2)*Z(1))                      
	RETURN                                                          
	END                                                             
									
									
	FUNCTION   EXT(I,A,B)                                           
	INTEGER    I                                                    
	COMPLEX*16  A(3),B(3),EXT                                       
	   IF(I.NE.1)  GOTO  1                                          
		EXT=A(2)*B(3)-A(3)*B(2)                                 
	RETURN
  1        IF(I.NE.2)  GOTO  2                                          
		EXT=A(3)*B(1)-A(1)*B(3)                                 
	RETURN                                                          
  2             EXT=A(1)*B(2)-A(2)*B(1)                                 
	RETURN                                                          
	END                                                             
									
	SUBROUTINE CDET(LAM,R0,DET,FREE)
	COMPLEX*16 LAM,DET,ALFA(3),CSINH,CCOSH,ALFA2,D1,D2,BETA
	COMPLEX*16 G(3),H(3),R(3),S(3),L(3),P(3),Y(3),N(3),T1,T2
	REAL*8 PARM(15),R0,A2,TAU,GAL,CAP,F,Q
	INTEGER FREE
	COMMON/PAT/PARM,NPAR

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC   This is the old case that gives R0=30
CC
CC      PARM(1) = A
CC      PARM(2) = SIGMA
CC      PARM(3) =GALILEO*SIGMA
CC      PARM(4) = 1/CAPILLARY
CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	A2 = PARM(1)*PARM(1)
	TAU = 1.D0/PARM(2)
	GAL = PARM(3)
	CAP = PARM(4)
	GAMMA = PARM(5)
	F = PARM(6)
	Q = PARM(7)
	UNO=(1.D0,0.D0)
	BETA = ((UNO + LAM*F)/(UNO + LAM*Q))
	CALL ROOT(LAM,R0,ALFA)
	DO 1 I=1,3
	ALFA2 = ALFA(I)*ALFA(I)
	D1= ALFA2 - 3*A2 - LAM*BETA*TAU
	D2= GAL + A2*CAP 
	T1 = D1/D2
	T2 = ALFA2 + A2 + GAMMA*(ALFA2 - A2)*(ALFA2 - A2 - LAM*BETA*TAU)
	N(I) = (1.D0,0.D0)
	G(I) = T2*CSINH(ALFA(I)) - GAMMA*R0*ALFA(I)*T1*CCOSH(ALFA(I))
	H(I) = LAM*D1*ALFA(I)*CCOSH(ALFA(I)) - A2*D2*BETA*CSINH(ALFA(I))
	L(I) = LAM*D1*ALFA(I)*CSINH(ALFA(I)) - A2*D2*BETA*CCOSH(ALFA(I))
	R(I) = ALFA(I)*(ALFA2-A2)*(ALFA2-A2-LAM*BETA*TAU)*CCOSH(ALFA(I))
	S(I) = ALFA(I)*(ALFA2-A2)*(ALFA2-A2-LAM*BETA*TAU)*CSINH(ALFA(I))
	P(I) = T2*CCOSH(ALFA(I)) - GAMMA*R0*ALFA(I)*T1*CSINH(ALFA(I))
	Y(I) = ALFA2*(ALFA2-2*A2-LAM*BETA*TAU)
1       CONTINUE
	IF (FREE) 2,3,2
2          CALL BOX(G,R,H,DET)
	   GOTO 5
3       CALL BOX(P,N,Y,D1)
	CALL BOX(ALFA,H,R,D2)
	DET = D1*D2
	CALL BOX(S,N,Y,D1)
	CALL BOX(ALFA,G,H,D2)
	DET = DET + (D1*D2)
	CALL BOX(L,N,Y,D1)
	CALL BOX(ALFA,R,G,D2)
	DET = DET + (D1*D2)
100     FORMAT(I1)
5        RETURN
	END


	
